##############################################
# $Id: myUtilsTemplate.pm 7570 2015-01-14 18:31:44Z rudolfkoenig $
#
# Save this file as 99_myUtils.pm, and create your own functions in the new
# file. They are then available in every Perl expression.

package main;

use strict;
use warnings;
use POSIX;

sub
myGiessenUtils_Initialize($$)
{
  my ($hash) = @_;
}

##############################################
# Start Giessautomaik
sub myGiessenUtils_at_Giessen(){

	my $State = "";

	if (ReadingsVal("du_Giessen_Auto","state","off") eq "on") {
	
		if (ReadingsVal("EG_au_MS_1","isRaining","no") eq "yes") {
			myGiessenUtils_resetValues("Pause");
			myGiessenUtils_sendMessage("Es regnet gerade => Giessen fällt aus");
			return;
		}

		
		if (ReadingsVal("du_Giessen_Logik","giessen_extra",0) == 1) {
			fhem("set EG_au_GP_1 Töpfe");
		} else {
			if (myGiessenUtils_lastCheck() != 0){
				$State = ReadingsVal("du_Giessen_Logik","state","Pause");
				fhem("set EG_au_GP_1 $State");
			}
		}
	}
}

##############################################
# Abbildung Giess-Logik
sub myGiessenUtils_at_Giessen_Logik($$){

	my($hour,$curmonth) = @_;
	
	if (ReadingsVal("du_Giessen_Auto","state","off") ne "on") {
		return;
	}
	
	my $Index = 0;
	my $State = '';
	my $IsReduced = 0;
	my $sMessage = '';

	
	if($hour >= 9 && $hour <= 18) {
		
		my $energy_cum = ReadingsVal("du_Giessen_Logik","energy_cum",0);
		my $energy_limit = ReadingsVal("du_Giessen_Logik","energy_limit",30);
		my $energy_cur = ReadingsVal("du_KG_ws_WR_Ges","EToday",0);
		my $energy =  round($energy_cur - $energy_limit,0);
		if ($energy > 0) {
			$energy_cum = $energy_cum + $energy;
			fhem ("setreading du_Giessen_Logik energy_cum $energy_cum");
		}

		my $temp_cum = ReadingsVal("du_Giessen_Logik","temp_cum",0);
		my $temp_limit = ReadingsVal("du_Giessen_Logik","temp_limit",20);
		my $temp_cur = ReadingsVal("EG_au_MS_1","temperature",0);
		my $temp =  round($temp_cur - $temp_limit,0);
		if ($temp > 0) {
			$temp_cum = $temp_cum + $temp;
			fhem ("setreading du_Giessen_Logik temp_cum $temp_cum");
		}
		
		my $Index_prev = ReadingsVal("du_Giessen_Logik","index_prev",0);
		
		$Index = $Index_prev + $energy_cum + $temp_cum;

		$State = myGiessenUtils_setState($Index);
		
		my $viel_limit = ReadingsVal("du_Giessen_Logik","viel_limit",100);

		if($hour == 18 && $Index > ($viel_limit * 1.5)) {								# Zusatzgiessen, wenn es besonders heiß ist
			fhem("setreading du_Giessen_Logik giessen_extra 1");
			fhem("set at_Giessen execNow");
		}
	}

	if($hour == 20) {
		my $Pause = ReadingsVal("du_Giessen_Logik","pause",0);
		
		my $IsReduced = 0;
		
		my $Fuellstand = ReadingsVal("EG_au_LS_1","Volume",5000);

		my $Fuellstand_delta = $Fuellstand - ReadingsVal("EG_au_LS_1","VolumePrev",0);
		my $State = ReadingsVal("du_Giessen_Logik","state","Pause");
		my $Index = ReadingsVal("du_Giessen_Logik","index",0);
		my @RegenHeute = split ":", ReadingsVal("EG_au_MS_1","statIsRainingChangeDayyes","00:00:00");
		
		if ($Pause > 0) {
			$Pause = $Pause - 1;
		}

		if ($Fuellstand_delta > 400) {
			$Pause = $Pause + round($Fuellstand_delta/400,0);
			$sMessage = "Es hatte in den letzten 24h $Fuellstand_delta Liter geregnet.";
		} elsif ($RegenHeute[0] > 3){
			$Pause = $Pause + round($RegenHeute[0]/3,0);
			$sMessage = "Es hatte in den letzten 24h ".$RegenHeute[0]."h geregnet.";
		}
		
		if ($Pause > 3) {
			$Pause = 3;
		}
		
		if ($Pause > 0) {
			$sMessage = $sMessage . " Index Reduzierung: $Index ";
			$Index = round($Index/($Pause+1),0);
			$sMessage = $sMessage . " => $Index ";
			$State = myGiessenUtils_setState($Index);
			$IsReduced = 1;
			if ($State ne "Pause"){
				$Pause = 0;
			}
		}
		
		fhem("setreading du_Giessen_Logik pause $Pause");

		if ($Pause > 0) {
			$sMessage = $sMessage . " Giesspause $Pause Tag(e)";
			fhem("set du_Giessen_Logik Pause");
		} else {
			if ($Fuellstand < 325 || ReadingsVal("du_Giessen_Not","state","off") eq "on") {	# bei 300 l ist die Zisterne leer
				if (ReadingsVal("du_Giessen_Not","state","off") ne "on") {
					fhem("set du_Giessen_Not on");
				}
				$sMessage = $sMessage . " Notprogramm: $State ($Index) - bitte rechtzeitig Wasserhahn aufdrehen!";
			} elsif ($Fuellstand < 800) {	# noch 500 l verfügbares Wasser
				if ($Index > ReadingsVal("du_Giessen_Logik","toepfe_limit",1000)){
					fhem("set du_Giessen_Logik Töpfe");
					$sMessage = $sMessage . " Die verfügbare Wassermenge in der Zisterne beträgt ".($Fuellstand-500)." Liter => Reduzierung auf Giessprogramm Töpfe.";
				} else {
					fhem("set du_Giessen_Logik Pause");
					$sMessage = $sMessage . " Die verfügbare Wassermenge in der Zisterne beträgt ".($Fuellstand-500)." Liter => heute wird nicht gegossen.";
				}
			} elsif ($Fuellstand < 1300) {	# noch 1000 l verfügbares Wasser
				if ($IsReduced != 1) {
					$Index = round($Index/2,0);
					$State = myGiessenUtils_setState($Index);
				}
				$sMessage = $sMessage . " Die verfügbare Wassermenge in der Zisterne beträgt ".($Fuellstand-500)." Liter => Reduzierung des Giessprogramms auf $State.";
			} else {
				fhem("set du_Giessen_Logik $State");
				$sMessage = $sMessage . " Geplantes Giessprogramm: $State ($Index)";
			}
		}
		
		fhem("setreading du_Giessen_Logik IsReduced $IsReduced");
		
		if ($sMessage ne '') {
			myGiessenUtils_sendMessage($sMessage);
		}
	}
}

##############################################
# Zwischen 20:00Uhr und dem Giesszeitpunkt kann viel passieren. Deshalb erfolgt noch ein letzter Check direkt vor dem Giessen
sub myGiessenUtils_lastCheck(){

	my $sMessage = '';

	my $Pause = ReadingsVal("du_Giessen_Logik","pause",0);
	
	my $Index = ReadingsVal("du_Giessen_Logik","index",0);
	my $State = ReadingsVal("du_Giessen_Logik","state","Pause");
	my $IsReduced = ReadingsVal("du_Giessen_Logik","IsReduced",0);

	if ($IsReduced == 0) {
		my $Fuellstand = ReadingsVal("EG_au_LS_1","Volume",5000);

		my $Fuellstand_delta = $Fuellstand - ReadingsVal("EG_au_LS_1","VolumePrev",0);
		my @RegenHeute = split ":", ReadingsVal("EG_au_MS_1","statIsRainingChangeDayyes","00:00:00");

		if ($Fuellstand_delta > 400) {
			$Pause = $Pause + round($Fuellstand_delta/400,0);
			$sMessage = "Es hatte in den letzten 24h $Fuellstand_delta Liter geregnet.";
		} elsif ($RegenHeute[0] > 3){
			$Pause = $Pause + round($RegenHeute[0]/3,0);
			$sMessage = "Es hatte in den letzten 24h ".$RegenHeute[0]."h geregnet.";
		}

		if ($Pause > 3) {
			$Pause = 3;
		}

		if ($Pause > 0) {
			$sMessage = $sMessage . " Index Reduzierung: $Index ";
			$Index = round($Index/2,0);
			$sMessage = $sMessage . " => $Index ";
			$State = myGiessenUtils_setState($Index);
			if ($State ne "Pause"){
				$Pause = 0;
			}
		}
	}

	if ($State ne "Pause"){
		$sMessage = $sMessage . " Geplantes Giessprogramm: $State ($Index)";
	}

	fhem("setreading du_Giessen_Logik pause $Pause");

	if ($sMessage ne '') {
		myGiessenUtils_sendMessage($sMessage);
	}
	
	return 1;
}

##############################################
# state setzen auf Basis des Index
sub myGiessenUtils_setState($){

	my($Index) = @_;
	my $State = "Pause";

	if ($Index >= ReadingsVal("du_Giessen_Logik","viel_limit",1000)){
		$State = "Viel";
	} elsif ($Index >= ReadingsVal("du_Giessen_Logik","wenig_limit",1000)){
		$State = "Wenig";
	} elsif ($Index >= ReadingsVal("du_Giessen_Logik","toepfe_limit",1000)){
		$State = "Töpfe";
	}
	fhem("setreading du_Giessen_Logik index $Index");
	fhem("set du_Giessen_Logik $State");
	return $State;
}

##############################################
# Nach dem Giessen wird alles wieder zurückgesetzt
sub myGiessenUtils_resetValues($){

	my($EVENT) = @_;
	my $sMessage = '';

	if (ReadingsVal("du_Giessen_Logik","giessen_extra",0) == 1) {		# Zusatzgiessen, wenn es besonders heiß ist
		fhem ("setreading du_Giessen_Logik Finished 1");
		return;
	}
	
	my $Index = ReadingsVal("du_Giessen_Logik","index","0");

	if ($EVENT eq "Pause"){
		if ($Index >= ReadingsVal("du_Giessen_Logik","toepfe_limit",1000)) {
			$Index = round($Index/2,0);
		}
		if ($Index > 0){
			$sMessage = "Als Index wird $Index behalten."
		} else {
			$sMessage = "Als Index wird nichts behalten."
		}
		$sMessage = '';			# In diesem Fall (erstmal) keine Message
	} else {
		$Index = 0;
		if (ReadingsVal("du_Giessen_Not","state","off") eq "on") {
			$sMessage = "beendet - bitte Wasserhahn schliessen !"
		} else {
			$sMessage = "beendet"
		}
		
		fhem ("setreading du_Giessen_Logik Finished 1");
	}
	
	fhem ("setreading du_Giessen_Logik index_prev $Index");
	fhem ("setreading du_Giessen_Logik index $Index");
	fhem ("setreading du_Giessen_Logik energy_cum 0");
	fhem ("setreading du_Giessen_Logik temp_cum 0");
	fhem ("set du_Giessen_Logik Pause");
	
	if ($sMessage ne '') {
		myGiessenUtils_sendMessage($sMessage);
	}
}

##############################################
# Versenden von Nachrichten
sub myGiessenUtils_sendMessage($){

	my($sMessage) = @_;
	
	if ($sMessage ne ''){
		fhem ("set tg_Bot message <b>Giessen: </b>$sMessage");
	}
}

##############################################
# Giessen notify
sub myGiessenUtils_ny_Giessen($){

	my($EVENT) = @_;

	my $dauer_gesamt = "0|0|0"; 
	my @dauer = 0;
	my $VolumePrev = ReadingsVal("EG_au_LS_1","Volume","0");

	fhem("setreading EG_au_LS_1 VolumePrev $VolumePrev");

#Log 3, Dumper('Volume_start 1 '.$Volume_start);	
	
	fhem("define tg0 at +00:00:05 set EG_au_GP_1 $EVENT");

	if ($EVENT eq "Viel") {$dauer_gesamt = ReadingsVal("du_Giessen_Logik","viel_plan","0|0|0")};
	if ($EVENT eq "Wenig") {$dauer_gesamt = ReadingsVal("du_Giessen_Logik","wenig_plan","0|0|0")};
	if ($EVENT eq "Töpfe") {$dauer_gesamt = ReadingsVal("du_Giessen_Logik","toepfe_plan","0|0|0")};
	if ($EVENT eq "Pause") {$dauer_gesamt = ReadingsVal("du_Giessen_Logik","pause_plan","0|0|0")};

	@dauer = split(/\|/,$dauer_gesamt);
	
	$dauer[2] = $dauer[2] + $dauer[1] + $dauer[0];

	if ($EVENT ne "Pause") {
		fhem("define tg6 at +00:".sprintf("%02d",($dauer[2])).":20 {myGiessenUtils_resetValues('".$EVENT."')}");
	}

}

##############################################
# Erzeuge aus Minuten hh:mm
sub myGiessenUtils_Format_Time($){

	my($minutes) = @_;
	my $hours = 0;
	
	while($minutes >= 60) {
		$hours = $hours + 1;
		$minutes = $minutes - 60;
	}
	
	return sprintf("%02d",($hours)).":".sprintf("%02d",($minutes));
}


####################################################################################################
# dynamisches Setzen des Energielimits basierend auf dem monatlichen Mittelwert der Energieerzeugung
sub myGiessenUtils_setEnergyLimit($){

	my($curmonth) = @_;
	my $value = ReadingsVal("du_Energy_Stat","M_Mittel_".sprintf("%02d",$curmonth),"0" );
	my @fld="";
	my $energy_limit = 30;
	if ($value ne "0"){
		@fld = split(" ", $value);
		if ($curmonth >=5 && $curmonth <=8) {
			$energy_limit = round($fld[0]/30*0.75,0);
		} else {
			$energy_limit = round($fld[0]/30,0);
		}
	}
	fhem("setreading du_Giessen_Logik energy_limit $energy_limit");
}
1;